package jp.mosp.common.part;

import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.payroll.dao.MKintaiKeisanDao;
import jp.mosp.payroll.dto.MKintaiKeisanDto;

/**
 * 勤怠計算に関するPartクラス
 * @author yoshida
 *	@version	0.0.2
 */
public class CalculatePart extends BasePart {

	/**
	 * コンストラクタ
	 */
	public CalculatePart() {
		super();
	}

	/**
	 * コンストラクタ
	 * @param partInfo
	 */
	public CalculatePart(PartInfo partInfo) {
		super(partInfo);
	}

	/**
	 * M_KINTAIKEISANテーブル用のDAO取得
	 * @return	初期化済みMKintaiKeisanDaoインスタンス
	 * @throws Exception
	 */
	public MKintaiKeisanDao getKeisanDao() throws Exception {
		return (MKintaiKeisanDao)getPreparedDao(MKintaiKeisanDao.class.getCanonicalName());
	}

	/**
	 * @return
	 * @throws Exception
	 */
	public MKintaiKeisanDto findForCalc() throws Exception {
		return getKeisanDao().findForCalc();
	}

	/**
	 * 勤怠締日取得
	 * @return	Date	対象年月日
	 * @throws MospException 
	 * @throws ClassNotFoundException 
	 * @throws NoSuchFieldException 
	 * @throws IllegalAccessException 
	 * @throws SQLException 
	 * @throws Exception
	 */
	public Date getCalcMonth() throws Exception {
		MKintaiKeisanDto dto = findForCalc();
		// 対象年月初期値取得
		Date targetDate = DatePart.getSystemDate();
		if (dto != null) {
			int closeDay = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
			if (closeDay == 0) {
				closeDay = 1;
			}
			targetDate = DatePart.getDate(dto.getKTNen(), dto.getKTTuki(), closeDay);
		}
		return targetDate;
	}

	/**
	 * 勤怠計算月取得
	 * @return yyyymm 計算年月
	 * @throws Exception
	 */
	public Date getCalcAttendance() throws Exception {
		// 対象年月日取得
		Date targetDate = getCalcMonth();
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(targetDate);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		// 締め日取得
		int minusMonth = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_MONTH)[2]);
		int closeDay   = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.roll(Calendar.MONTH, minusMonth * -1);
		if (closeDay != 0) {
			cal.roll(Calendar.MONTH, 1);
			cal.set(Calendar.DAY_OF_MONTH, closeDay);
		}
		return cal.getTime();
	}

	/**
	 * 給与支給対象年月日取得
	 * @param targetDate 対象日
	 * @return	（勤怠集計月）月（給与支給日）日
	 * @throws Exception
	 */
	public Date getCalcPayment(Date targetDate) throws Exception {
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(targetDate);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		// 支給日条件取得
		int plusMonth	= Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_PROVIDED_DATE, CommonConst.TCD_MONTH)[2]);
		int providedDay	= Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_PROVIDED_DATE, CommonConst.TCD_DAYS)[2]);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.roll(Calendar.MONTH, plusMonth * 1);
		// 1月の場合、支給日条件によって翌年を取得
		if ((cal.get(Calendar.MONTH) == 0)	&& plusMonth != 0) {
			cal.roll(Calendar.YEAR, 1);
		}
		if (providedDay != 0) {
			cal.set(Calendar.DAY_OF_MONTH, providedDay);
		}
		return cal.getTime();
	}

	/**
	 * 給与支給日取得
	 * @return	Date	対象年月日
	 * @throws Exception
	 */
	public Date getCalcPayment() throws Exception {
		MKintaiKeisanDto dto = findForCalc();
		// 対象年月初期値取得
		Date targetDate = getCalcPayment(DatePart.getSystemDate());
		if (VariousPart.chkExistDto(dto)) {
			targetDate = DatePart.getDate(dto.getKSNen(), dto.getKSTuki(), dto.getKShi());
		}
		return targetDate;
	}

	/**
	 * 集計開始日取得
	 * @param targetMonth 対象月
	 * @return 集計開始日
	 * @throws Exception
	 */
	public Date getStartDate(Date targetMonth) throws Exception {
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(targetMonth);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		// 締め日取得
		int minusMonth = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_MONTH)[2]);
		int closeDay   = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		/*						
		 *  	2009/01/20	m.yoshida	締め日対応
		 */
		cal.add(Calendar.MONTH, minusMonth * -1);
		// 集計開始日計算
		if (closeDay != 0) {
			if (MospUtility.getDay(targetMonth) <= closeDay) {
				cal.add(Calendar.MONTH, -1);
			}
			cal.set(Calendar.DAY_OF_MONTH, closeDay);
			cal.add(Calendar.DAY_OF_MONTH, 1);
		}
		return cal.getTime();
	}

	/**
	 * 集計終了日取得
	 * @param targetMonth 対象月
	 * @return 集計終了日
	 * @throws Exception
	 */
	public Date getEndDate(Date targetMonth) throws Exception {
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		/*						
		 *  	2009/01/20	m.yoshida	締め日対応
		 */
		// 締め日取得
		int closeDay   = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
		// 開始日を取得
		cal.setTime(getStartDate(targetMonth));
		// 一ヶ月加算する
		cal.add(Calendar.MONTH, 1);
		if (closeDay != 0) {
			// 指定日締め
			cal.roll(Calendar.DAY_OF_MONTH, -1);
		} else {
			// 末日締め
			cal.add(Calendar.MONTH, -1);
			// 対象月の最終日をセット
			cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
		}
		return cal.getTime();
	}

	/**
	 * 集計月取得
	 * @param targetDate 対象日
	 * @return 集計月
	 * @throws Exception
	 */
	public Date getCurrentDate(Date targetDate) throws Exception {
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(targetDate);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		// 締め日取得
		int minusMonth = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_MONTH)[2]);
		int closeDay   = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
		// 集計月取得
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.roll(Calendar.MONTH, minusMonth * -1);
		if (closeDay != 0) {
			if (MospUtility.getDay(targetDate) > closeDay) {
				cal.roll(Calendar.MONTH, 1);
			}
		}
		return cal.getTime();
	}

	/**
	 * 表示用開始年月日
	 * <p>2009/01/20	m.yoshida	追加</p>
	 * @param targetDate	対象年月日	
	 * @return 表示用開始年月日
	 * @throws Exception
	 */
	public Date getStartDateForList(Date targetDate) throws Exception {
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(targetDate);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		// 締め日取得
		int closeDay   = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
		// 集計開始日計算
		if (closeDay != 0) {
			if (MospUtility.getDay(targetDate) <= closeDay) {
				cal.add(Calendar.MONTH, -1);
			}
			cal.set(Calendar.DAY_OF_MONTH, closeDay);
			cal.add(Calendar.DAY_OF_MONTH, 1);
		}
		return cal.getTime();
	}

	/**
	 * 表示用終了年月日
	 * <p>2009/01/20	m.yoshida	追加</p>
	 * @param targetDate	対象年月日
	 * @return 表示用開始年月日
	 * @throws Exception
	 */
	public Date getEndDateForList(Date targetDate) throws Exception {
		// カレンダー取得
		Calendar cal = Calendar.getInstance();
		// 締め日取得
		int closeDay   = Integer.parseInt(mospcode().getMosPCode(CommonConst.TID_CALCULATION, CommonConst.TCD_DAYS)[2]);
		// 開始日を取得
		cal.setTime(getStartDateForList(targetDate));
		// 一ヶ月加算する
		cal.add(Calendar.MONTH, 1);
		if (closeDay != 0) {
			// 指定日締め
			cal.roll(Calendar.DAY_OF_MONTH, -1);
		} else {
			// 末日締め
			cal.add(Calendar.MONTH, -1);
			// 対象月の最終日をセット
			cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
		}
		return cal.getTime();
	}


	/**
	 * 勤怠計算終了判断
	 * @since	0.0.2
	 * @return
	 * <p>
	 * 勤怠計算が完了している場合true、そうでない場合false
	 * </p>
	 * @throws Exception
	 */
	public boolean isCalculateFinish() throws Exception {
		return isCalculateFinish(findForCalc());
	}

	/**
	 * 勤怠計算終了判断
	 * @since	0.0.2
	 * @param dto	対象DTO
	 * @return
	 * <p>
	 * 勤怠計算が完了している場合true、そうでない場合false
	 * </p>
	 * @throws Exception
	 */
	public static boolean isCalculateFinish(MKintaiKeisanDto dto) throws Exception {
		if (VariousPart.chkExistDto(dto) 
				&& CommonConst.NUM_ATTENDANCE_CALCULATE_FLAG_ON.equals(dto.getKKanryou())
		) {
			return true;
		}
		return false;
	}

	/**
	 * 対象年月日勤怠締め日判断
	 * @since	0.0.2
	 * @param targetDate		対象年月日
	 * @return
	 * <p>
	 * 対象年月日が勤怠締め日より前ならtrue、そうでない場合false
	 * <p>
	 * @throws Exception
	 */
	public boolean isBeforeCalcMonth(Date targetDate) throws Exception {
		// 勤怠締め日
		Date calcMonth = getCalcMonth();
		// 勤怠計算終了時は翌月
		if (isCalculateFinish()) {
			calcMonth = DatePart.addMonth(calcMonth, 1);
		}
		// 勤怠集計月より前の場合
		if (calcMonth.compareTo(targetDate) > 0) {
			return true;
		}
		return false;
	}

}
